package com.jiayue.simulation.ice102.handler;

import com.jiayue.simulation.ice102.service.ClientService;
import com.jiayue.simulation.util.SpringContextHolder;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelInboundHandlerAdapter;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * 服务端控制器
 *
 * @author tl
 */
@Slf4j
public class ClientHandler extends ChannelInboundHandlerAdapter {



    @Autowired
    ClientService clientService = SpringContextHolder.getApplicationContext().getBean(ClientService.class);

    //连接时触发
    @Override
    public void channelActive(ChannelHandlerContext ctx) throws Exception {

        ctx.channel().writeAndFlush("1049FFFF4716");
    }

    //接收消息触发
    @Override
    public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {

        log.info("接收消息：{}",msg);
        Thread.sleep(1000);
        String s = clientService.sendMessage(msg.toString());
        log.info("发送消息：{}",s);
        ctx.channel().writeAndFlush(s);
    }

    //处理异常， 一般是需要关闭通道
    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause)
            throws Exception {
        ctx.channel().close();
    }

    //客户端重连
    @Override
    public void channelInactive(ChannelHandlerContext ctx) throws Exception {
        super.channelInactive(ctx);
    }
}